package bootcampdia7.Empleados;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.websocket.server.PathParam;

@Controller
public class EmpleadoController {
    @Autowired
    private Empleado empleado;

    @RequestMapping("/empleado")
    public ModelAndView serveEmpleadoForm(){
        return new ModelAndView("empleadoForm", "empleado", new Empleado());
    }

    @PostMapping("/addEmployee")
    public String submitEmployee(@ModelAttribute("employee") Empleado empleado, BindingResult bindingResult, ModelMap model){
        if(bindingResult.hasErrors()){
            return "ERROR";
        }
        model.addAttribute(empleado);
        Empleado.empleados.add(empleado);
        return "empleadoDetail";
    }

    @RequestMapping("/empleado/{empId}")
    public ModelAndView getEmpleado(@PathVariable("empId") long empId){
        ModelAndView mv = new ModelAndView();
        empleado = Empleado.empleados.get((int)empId);
        mv.addObject("empleado", empleado);
        mv.setViewName("empleadoDetail");
        System.out.println(mv);
        return mv;
    }
}
