package bootcampdia7.Stack;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Stack;

@Controller
public class StackController {
    private Stack<Integer> stack = new Stack<Integer>();
    @Autowired
    private StackValue stackValue;

    @RequestMapping("/stack")
    public ModelAndView serveMainPage(HttpServletRequest request){
        ModelAndView mv = new ModelAndView("main", "StackValue", new StackValue());
        String popValue = request.getParameter("popvalue");
        mv.addObject("stack", stack);
        mv.addObject("popValue", popValue);
        return mv;
    }

    @PostMapping("/push")
    public String push(@ModelAttribute("StackValue") StackValue value, BindingResult bindingResult, ModelMap model){
//        ModelAndView mv = new ModelAndView("main", "StackValue", new StackValue());
        if(bindingResult.hasErrors()){
            return "ERROR";
        }
//        mv.addObject("stack", stack);
        stack.push(value.getValue());
        return "redirect:/stack";
    }

    @GetMapping("/pop")
    public String pop(HttpServletRequest request){
        int value = 0;
        try{
            value = stack.pop();
        }catch (Exception e){
            System.out.println("vacio");
            return "redirect:/stack";
        }
        return "redirect:/stack?popvalue="+value;
    }
}
